<?php
$plugin_info = array(
						'pi_name'			=> 'JB Friendly',
						'pi_version'		=> '1.1',
						'pi_author'			=> 'Joel Bradbury',
						'pi_author_url'		=> 'http://joelbradbury.net/code/friendly',
						'pi_description'	=> 'Convert date, relative to another to a user friendly format',
						'pi_usage'			=> Jb_friendly::usage()
					);


class Jb_friendly {

    var $return_data;   
		//set the default return format if the date is older than the stop_after time 
		//ie. August 19th, 2010
		var $default_format = "%F %d%S, %Y";    

    /** ----------------------------------------
    /**  Character Limiter
    /** ----------------------------------------*/

	function Jb_friendly($timestamp = '') {
		                            
	  $this->EE =& get_instance();
		
		$return = '';                          
		// collect our params
		$entry_date 		= ($this->EE->TMPL->fetch_param('entry_date')!='' ? $this->EE->TMPL->fetch_param('entry_date') : ''); //the date we're interested in.
		$relative_date 	= ($this->EE->TMPL->fetch_param('relative_date')!='' ? $this->EE->TMPL->fetch_param('relative_date') : time());  //the date we're want a friendly relative time period to
		$stop_after 		= ($this->EE->TMPL->fetch_param('stop_after')!='' ? strtolower($this->EE->TMPL->fetch_param('stop_after')) : '');
		$date_format 		= ($this->EE->TMPL->fetch_param('format')!='' ? $this->EE->TMPL->fetch_param('format') : $this->default_format);	 
		                                                      
		//if we haven't got an entry_date bail here and return nothing
		if($entry_date=='') return '';
		
		//if we're not passed a date to compare, use right now
		if($relative_date != '' AND strtotime($relative_date) ) $relative_date = strtotime($relative_date);
		else $relative_date = time();  
		
		                                              
		//the date might be coming in as an RFC 822 formatted date
		if(strtotime($entry_date)) $entry_date = strtotime($entry_date);   
		
		
		$relative_period = $entry_date - $relative_date;  
	 
	 //test to see if the time is in the future, or the past 
		$direction = "to go";
		if($relative_period<0) {
			$direction = "ago";
			$relative_period = -$relative_period;
		}                                     
		//localize our periouds
		$elapsed = $this->EE->localize->set_localized_time($relative_period);
		$timestamp = $this->EE->localize->set_localized_time($relative_period);
		                                                                                           
		switch ($stop_after) 
		{
			case '1 day': $stop_after = 3600*24; break;
			case '1 week': $stop_after = 3600*24*7; break;
			case '1 month': $stop_after = 3600*24*30; break;
			case '1 year': $stop_after = 3600*24*365; break;
			default: ''; // empty on default
		}                                                                   
		                                                                                                                           
		$entry_date = $this->EE->localize->decode_date($date_format, $entry_date);
		 
		$relative_wordy = $this->time_elapsed_string($timestamp);   
		if($timestamp>$stop_after && $stop_after!='') {
			$relative_wordy = $entry_date;
			$direction = '';			
		}                                    
		                           
		$tagdata = $this->EE->TMPL->tagdata; 
     foreach ($this->EE->TMPL->var_single as $key => $val)
     {  
	      if ($key == 'direction') $tagdata = $this->EE->TMPL->swap_var_single($key, $direction, $tagdata);
				if ($key == 'friendly') $tagdata = $this->EE->TMPL->swap_var_single($key, $relative_wordy, $tagdata);
				if ($key == 'full_date') $tagdata = $this->EE->TMPL->swap_var_single($key, $entry_date, $tagdata);
			}

 			$return .= trim($tagdata)."\n";
				
    	$this->return_data = $return; 		
	}

	function time_elapsed_string($ptime) {
		             
			$year = 'year';
			$month = 'month';
			$day = 'day';
			$hour = 'hour';
			$min = 'min.';
			$sec = 'sec.';
			$postfix = 's';
			$ago = '';
			
			$etime = $ptime;
      if ($etime < 1)  return '0 seconds';


      $a = array( 12 * 30 * 24 * 60 * 60  		 =>  $year,
                       30 * 24 * 60 * 60       =>  $month,
                       24 * 60 * 60            =>  $day,
                       60 * 60                 =>  $hour,
                       60                      =>  $min,
                       1                       =>  $sec
                       );

     foreach ($a as $secs => $str) {
         $d = $etime / $secs;

				 if ($d >= 1) {					
					if($secs == 60) {
						$str = 'min.';
						$postfix = '';
					}

	        $r = round($d);
	        return $r . ' ' . $str . ($r > 1 ? $postfix : '') . $ago;
       	}
     }
 }
	/* END */
    
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------

// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
                                             
See documentation in the README or at http://joelbradbury.net/code/friendly for useage instructions
      

<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
/* END */


}